/// <reference types="node" />
/// <reference types="node" />
import { Readable } from "stream";
import { AudioInput, AudioInputArgs } from "../AudioInput/AudioInput";
import { AudioSampleRate, AudioBitDepth, AudioEndianness } from "../Types/AudioTypes";
type delayTimeType = number | (() => number);
type preProcessDataType = (data: Buffer) => Buffer;
interface AudioMixerArgs {
    sampleRate?: AudioSampleRate;
    channels?: number;
    bitDepth?: AudioBitDepth;
    endianness?: AudioEndianness;
    volume?: number;
    highWaterMark?: number | null;
    generateSilent?: boolean;
    silentDuration?: number | null;
    preProcessData?: preProcessDataType;
    delayTime?: delayTimeType;
    autoClose?: boolean;
}
declare class AudioMixer extends Readable {
    private mixerOptions;
    private inputs;
    private isMixerClosed;
    private delayTimeValue;
    constructor(mixerArgs?: AudioMixerArgs);
    _read(): void;
    get getOptions(): AudioMixerArgs;
    setVolume(volume: number): this;
    setHighWaterMark(highWaterMark: number | null): this;
    setgenerateSilent(generateSilent: boolean): this;
    setSilentDuration(silentDuration: number | null): this;
    setPreProcessData(preProcessData: preProcessDataType): this;
    setDelayTime(delayTime: delayTimeType): this;
    setAutoClose(autoClose: boolean): this;
    createAudioInput(inputArgs: AudioInputArgs): AudioInput;
    removeAudioInput(audioInput: AudioInput): this;
    close(): this;
    private loopRead;
}
export { AudioMixer, AudioMixerArgs };
